package screen

import (
	"fyne.io/fyne/v2"
	"fyne.io/fyne/v2/widget"
)

// ListItemTemplate is a template for a list item.
// It implements the fyne.CanvasObject interface and TemplateScreenHandler
type ListItemTemplate struct {
	fyne.CanvasObject
	*TemplateScreenHandler
}

// CreateRenderer implements the fyne.CanvasObject interface
func (i *ListItemTemplate) CreateRenderer() fyne.WidgetRenderer {
	return widget.NewSimpleRenderer(i.CanvasObject)
}

// NewListItemTemplate creates a new ListItemTemplate
func NewListItemTemplate(
	obj fyne.CanvasObject,
	screenHandler *TemplateScreenHandler,
) *ListItemTemplate {
	return &ListItemTemplate{
		CanvasObject:          obj,
		TemplateScreenHandler: screenHandler,
	}
}
